/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: id.h,v 1.3 2000/11/14 16:57:33 takayuki Exp $
 */

//------------------------------------------------------------
// ID - class definition
//
//   class ID is a type for managing objects' identifier and
//		assigning suitable identifier automatically for new
//		object.

#ifndef __ID_H

#include <set>

class ID
{
protected:
	long LowerBound;	//IDs which equal upper or lower bound are available
	long UpperBound;	
	std::set<long> AssignedIdentifier;

public:
	ID(const long Size = 255);
	explicit ID(long Lower, unsigned long Size = 255);
	explicit ID(long Lower, long Upper = 255);

	operator const bool(void);				//Availability check
	operator const unsigned long(void);	//Count of items
	bool operator [](long);							//Status of each item

	bool Assign(long);
	bool Resign(long);
	
	bool IsAssigned(long);
	long GetMaxID(void);
	long GetMinID(void);
	unsigned long GetCount(void);

	long GetNewID(void);		//Method GetNewID reports a suitable new identifier, but never reserves one.

	bool IsAvailable(void);		//This method checks up on the availablity of these IDs with ITRON ID numbering policy.
};

inline ID::operator const bool (void)
{	return this->IsAvailable();	}

inline ID::operator const unsigned long(void)
{	return this->AssignedIdentifier.size();	}

inline bool ID::operator [] (long value)
{	return this->AssignedIdentifier.find(value) != this->AssignedIdentifier.end();	}

inline bool ID::IsAssigned (long value)
{	return this->AssignedIdentifier.find(value) != this->AssignedIdentifier.end();	}

inline unsigned long ID::GetCount(void)
{	return AssignedIdentifier.size();	}

#endif

//---
// Degined and Programmed by S.D.F. in Oct,2000