/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: staticapi.h,v 1.2 2000/11/14 15:56:26 takayuki Exp $
 */

//------------------------------------------------------------
// StaticAPI - class definition
//

#ifndef __STATICAPI_H
#define __STATICAPI_H

#include "array.h"
#include "exception.h"

class StaticAPI
{
private:
	char * CheckParameter_Primitive(Array *,char *);
protected:
	void CheckParameter(Array *, char *);
	void CheckParameterCount(Array &,unsigned int, unsigned int=0);
	void CheckParameterType(Array &,unsigned int,Valient::tagType);
	void CheckParameterType(Array &,unsigned int,Array::tagType);

public:
	StaticAPI(void) {};
	virtual ~StaticAPI(void) {};

	virtual char * GetAPIName(void) =0;
	virtual void Body(Array & Parameter) =0;
};

inline void StaticAPI::CheckParameterCount(Array & param,unsigned int start, unsigned int end)
{
	if((param.Size() < start) || (end != 0 && param.Size() > end))
		throw Exception("οʤ");
}

inline void StaticAPI::CheckParameterType(Array & param,unsigned int offset, Valient::tagType type)
{
	if(param.Size() > offset || param.GetValuePtr(offset) == 0l || !(param[offset] == type))
		throw Exception("ηʤ");
}

inline void StaticAPI::CheckParameterType(Array & param,unsigned int offset, Array::tagType type)
{
	if((type != Array::EMPTY) && param.IsArray(offset) != (type == Array::ARRAY) ? true : false)
		throw Exception("ηʤ");
}

inline void StaticAPI::CheckParameter(Array * param, char * format)
{
	if(CheckParameter_Primitive(param,format)!=0l)
		throw Exception("Internal error : Illegal parameter descriptor (Unterminated descriptor)");
}

#endif

//---
// Degined and Programmed by S.D.F. in Oct,2000