/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: valient.cpp,v 1.3 2000/11/14 16:57:33 takayuki Exp $
 */

#include "valient.h"

Valient::Valient(const Valient & src)
{
	switch(src.Type)
	{
	case STRING:
		Type = EMPTY;
		this->Set(src.String.Entity);
		break;

	default:
		Type = src.Type;
		Double = src.Double;
	}
}

Valient::~Valient(void)
{	Clear();	}

bool Valient::Set(int src)
{
	Clear();
	Type = INTEGER;
	Integer = src;
	return true;
}

bool Valient::Set(unsigned int src)
{
	Clear();
	Type = UNSIGNEDINTEGER;
	UnsignedInteger = src;
	return true;
}

bool Valient::Set(double src)
{
	Clear();
	Type = DOUBLE;
	Double = src;
	return true;
}

bool Valient::Set(char * src)
{
	unsigned int i,j;

	Clear();
	Type = STRING;
	
	for(i=0;*(src+i)!='\x0';i++);

	String.Size = i;
	String.Entity = new char [i+1];
	for(j=0;j<=i;j++)
		*(String.Entity+j)=*(src+j);

	return true;
}

bool Valient::Set(void * src)
{
	Clear();
	Type = POINTER;
	Pointer = src;
	return true;
}

bool Valient::Clear(void)
{
	switch(Type)
	{
	case STRING:
		if(String.Entity != 0l)
			delete [] String.Entity;
		String.Entity = 0l;
		break;
	}
	Type = EMPTY;
	return true;
}

Valient & Valient::operator =(const Valient & src)
{
	Clear();
	
	Type = src.Type;
	if(src.Type == STRING)
	{
		unsigned int i;
		String.Entity = new char[src.String.Size+1];
		for(i=0;i<=src.String.Size;i++)
			*(String.Entity+i) = *(src.String.Entity+i);
		String.Size = src.String.Size;
	}else
		Double = src.Double;

	return *this;
}

