/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.1 2000/11/14 16:30:22 honda Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼RSH3ѡ
 *  SCI1
 */

#include "sh3.h"
#include "sys_config.h"
#include "cpu_config.h"


/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL_IN	 SCI1_RXI_INTEVT       
#define INHNO_SERIAL_OUT SCI1_TXI_INTEVT	
#define INHNO_SERIAL_ERROR  SCI1_BRI_INTEVT

/*
 *  ꥢݡȤΥϡɥ¸
 *  Not yet! m68kΤ褦˥ȥ쥸¤Τˤ롣
 */
typedef struct hardware_serial_port_descripter {
    INT	  *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL  sendflag;        /* ߥ֥͡ե饰 */
} HWPORT;



/*
 * SCI1γߥ٥
 * Ʊꤹ롣
 */


#define SCI1INTLVL   6


/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[1] = { 0 } ;	/* ѥե饰 */

#define HWPORT1	{ &initflag[0],  0 }


/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
    SCI1.SCSCR1 = 0;          /* SCI1,PåȤ */
    SCI1.SCFCR1 = SCFCR1_TFRST | SCFCR1_RFRST; /* FIFO򥯥ꥢ */
    SCI1.SCSMR1 = 0;          /* 8ǡ,1ȥåץӥå,no parity */
    SCI1.SCBRR1 = SCI1_BPS_VALUE;        

    /*
     * ܡ졼Ȥ塢1ʬԤʤФʤʤ
     * ХơȥȥΥեå奫󥿤Ȥ
     * 1ʬԤ
     */

    *RFCR = RFCR_CLEAR;
    while( *RFCR < WAIT_RFCR_FOR_SCI);
    
        
    SCI1.SCFCR1 = 0x30;           /* R-FIFO=1,T-FIFO=1 ȥꥬ */

    SCI1.SCSSR1 = 0x0060;         /* 顼ե饰򥯥ꥢ           */
    SCI1.SCSCR1 = 0x70;           /* Start Tx Rx ߵ   */

    
    /*
     * ߴϢ
     * 顼ϥɥϿ٤
     */
    if (initflag[0] <= 0) {
        *IPRE=(*IPRE&0xf0ff)|(SCI1INTLVL<<8); /* ߥ٥ */
        define_int_plevel(SCI1_RXI_INTEVT,SCI1INTLVL);
        define_int_plevel(SCI1_TXI_INTEVT,SCI1INTLVL);
        *IRR1=0;                              /* ׵᥯ꥢ */  
    }
    
    *(p->initflag) = 1;			/* ե饰 */
    return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
	*(p->initflag) = -1;		/* ե饰           */
    SCI1.SCSCR1 = 0x00;         /* ꥢ륳ȥ */
    *IPRE=(*IPRE&0xf0ff);       /* ߥޥꥢ       */
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler_in()
{
    if (initflag[0] > 0)
        serial_handler_in(1);        
    else
        SCI1.SCSCR1 &= ~(SCSCR1_RIE);
}

Inline void
hw_serial_handler_out()
{
    if (initflag[0] > 0)
        serial_handler_out(1);
    else
        SCI1.SCSCR1 &= ~(SCSCR1_TIE);
}


/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return((SCI1.SCSSR1 & SCSSR1_RDF)!=0);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
    return((SCI1.SCSSR1 & SCSSR1_TDFE) !=0);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    byte data;
    data = SCI1.SCFRDR1;         
    SCI1.SCSSR1 &= ~SCSSR1_RDF ; 
    return data;
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
    SCI1.SCFTDR1=c;
    SCI1.SCSSR1 &= ~(SCSSR1_TDFE |SCSSR1_TEND);  
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    if (!(p->sendflag)) {
        SCI1.SCSCR1 |= SCSCR1_TIE;   /* ׵ */
        p->sendflag = 1;
    }
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
        SCI1.SCSCR1 &= ~SCSCR1_TIE; /* ׵ػ */
        p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */





















