/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sh3.h,v 1.1 2000/11/14 16:29:53 honda Exp $
 */

#ifndef _SH3_H_
#define _SH3_H_

/*
 *  SH3(SH7709A,SH7709,SH7708)쥸
 */
typedef unsigned char   byte;
typedef volatile byte   IOREG;          
typedef unsigned short  word;
typedef volatile word   HIOREG;
typedef volatile int    LIOREG;


/*
 *  㳰٥ȥ쥸
 */
#define TRA	        0xFFFFFFD0		
#define EXPEVT	    0xFFFFFFD4		
#define INTEVT	    0xFFFFFFD8		
#define INTEVT2	    0xA4000000		

/*
 *   ХơȥȥϢ
 */
#define	RFCR	((HIOREG *)(0xffffff74))	

#define    RFCR_CLEAR         0xa400


/*
 * ߤˤäINTEVT2쥸ꤵ
 */
#define    TMU0_INTEVT        0x400
#define    IRQ0_INTEVT        0x600
#define    SCI_RXI_INTEVT     0x500
#define    SCI_TXI_INTEVT     0x520
#define    SCI_BRI_INTEVT     0x4ed
#define    SCI1_RXI_INTEVT    0x8a0
#define    SCI1_TXI_INTEVT    0x8e0
#define    SCI1_BRI_INTEVT    0x8c0
#define    SCIF_RXI_INTEVT    0x920
#define    SCIF_TXI_INTEVT    0x960
#define    SCIF_BRI_INTEVT    0x940


        
/*
 * ߥȥ顼쥸
 */
#define	ICR0	((HIOREG *)(0xfffffee0))	
#define	ICR1	((HIOREG *)(0xa4000010))	
#define	ICR2	((HIOREG *)(0xa4000012))	
#define	PINTER	((HIOREG *)(0xa4000014))	
#define	IPRA	((HIOREG *)0xfffffee2)		
#define	IPRB	((HIOREG *)0xfffffee4)		
#define	IPRC	((HIOREG *)(0xa4000016))	
#define	IPRD	((HIOREG *)(0xa4000018))	
#define	IPRE	((HIOREG *)(0xa400001a))	
#define	IRR0	((IOREG  *)(0xa4000004))	
#define	IRR1	((IOREG  *)(0xa4000006))	
#define	IRR2	((IOREG  *)(0xa4000008))	



/*
 * ޡ쥸
 */
typedef struct{
    IOREG  TOCR;
    IOREG  dummy1;
    IOREG  TSTR;
    IOREG  dummy2;
    LIOREG TCOR0;
    LIOREG TCNT0;
    HIOREG TCR0;
    LIOREG TCOR1;
    LIOREG TCNT1;
    HIOREG TCR1;
    LIOREG TCOR2;
    LIOREG TCNT2;
    HIOREG TCR2;
} tmu;

#define TMU  (*(volatile tmu *)0xfffffe90)
                              
#define	TMU_STR0	0x01
#define	TMU_STR1	0x02
#define	TMU_STR2	0x04
#define TCR_UNF     0x0100    



/*
 *  ꥢ륳ߥ˥󥤥󥿡ե(SCI)
 */
typedef struct{
    IOREG  SCSMR;
    IOREG  dummy1;    
    IOREG  SCBRR;
    IOREG  dummy2;    
    IOREG  SCSCR;
    IOREG  dummy3;        
    IOREG  SCTDR;
    IOREG  dummy4;            
    IOREG  SCSSR;
    IOREG  dummy5;            
    IOREG  SCRDR;
} sci;


#define SCI (*(volatile sci *)0xfffffe80)


/*
 *  ꥢ륳ߥ˥󥤥󥿡ե(SCI)
 *  ݡSCȥ/ǡ쥸
 *  SH7709ڤSH7709AΤ
 */
#define	SCPCR	((IOREG  *)(0xa4000136))	
#define	SCPDR	((HIOREG *)(0xa4000116))	


/*
 *  ꥢ륳ߥ˥󥤥󥿡ե(SCI)
 *  ꥢݡȥ쥸
 *  SH7708Τ
 */
#define	SCSPTR	((HIOREG *)(0xffffff7c))	

#define	SCSMR_CHR	  0x0040
#define	SCSMR_PE	  0x0020
#define	SCSMR_OE	  0x0010
#define	SCSMR_STOP	  0x0008
#define	SCSMR_CKS1	  0x0002
#define	SCSMR_CKS0	  0x0001

#define SCSCR_TIE	  0x0080
#define SCSCR_RIE	  0x0040
#define SCSCR_TE	  0x0020
#define SCSCR_RE	  0x0010
#define SCSCR_CKE1	  0x0002
#define SCSCR_CKE0	  0x0001

#define SCSSR_TDRE	  0x80
#define SCSSR_RDRF	  0x40
#define SCSSR_ORER	  0x20
#define SCSSR_FER	  0x10
#define SCSSR_PER	  0x08
#define SCSSR_TEND	  0x04
#define SCSSR_MPB	  0x02
#define SCSSR_MPBT	  0x01



/*
 *  FIFOդꥢ륳ߥ˥󥤥󥿡ե(SCIF)쥸
 *  SH7709ڤSH7709AΤ
 */

typedef struct{
    IOREG  SCSMR2;
    IOREG  dummy1;    
    IOREG  SCBRR2;
    IOREG  dummy2;    
    IOREG  SCSCR2;
    IOREG  dummy3;        
    IOREG  SCFTDR2;
    IOREG  dummy4;            
    HIOREG SCSSR2;
    IOREG  SCFRDR2;
    IOREG  dummy5;                
    IOREG  SCFCR2;
    IOREG  dummy6;                    
    HIOREG SCFDR2;
} scif;

#define SCIF (*(volatile scif *)0xa4000150)

#define	SCSMR2_CHR	  0x0040
#define	SCSMR2_PE	  0x0020
#define	SCSMR2_OE	  0x0010
#define	SCSMR2_STOP	  0x0008
#define	SCSMR2_CKS1	  0x0002
#define	SCSMR2_CKS0	  0x0001

#define SCSCR2_TIE	  0x0080
#define SCSCR2_RIE	  0x0040
#define SCSCR2_TE	  0x0020
#define SCSCR2_RE	  0x0010
#define SCSCR2_CKE1	  0x0002
#define SCSCR2_CKE0	  0x0001

#define SCSSR2_ER	  0x0080
#define SCSSR2_TEND	  0x0040
#define SCSSR2_TDFE	  0x0020
#define SCSSR2_BRK	  0x0010
#define SCSSR2_FER	  0x0008
#define SCSSR2_PER	  0x0004
#define SCSSR2_RDF	  0x0002
#define SCSSR2_DR	  0x0001


#define SCFCR2_RTRG1  0x0080
#define SCFCR2_RTRG0  0x0040
#define SCFCR2_TTRG1  0x0020
#define SCFCR2_TTRG0  0x0010
#define SCFCR2_MCE	  0x0008
#define SCFCR2_TFRST  0x0004
#define SCFCR2_RFRST  0x0002
#define SCFCR2_LOOP	  0x0001




/*
 *  IrDA (SCI1)쥸
 *  SH7709ڤSH7709AΤ
 */

typedef struct{
    IOREG  SCSMR1;
    IOREG  dummy1;    
    IOREG  SCBRR1;
    IOREG  dummy2;    
    IOREG  SCSCR1;
    IOREG  dummy3;        
    IOREG  SCFTDR1;
    IOREG  dummy4;            
    HIOREG SCSSR1;
    IOREG  SCFRDR1;
    IOREG  dummy5;                
    IOREG  SCFCR1;
    IOREG  dummy6;                    
    HIOREG SCFDR1;
} sci1;

#define SCI1 (*(volatile sci1 *)0xa4000140)

#define	SCSMR1_IRMOD    0x0080
#define	SCSMR1_CHR	    0x0040
#define	SCSMR1_PE	    0x0020
#define	SCSMR1_OE	    0x0010
#define	SCSMR1_STOP	    0x0008
#define	SCSMR1_CKS1	    0x0002
#define	SCSMR1_CKS0	    0x0001

#define SCSCR1_TIE      0x0080
#define SCSCR1_RIE      0x0040
#define SCSCR1_TE       0x0020
#define SCSCR1_RE       0x0010
#define SCSCR1_CKE1     0x0002
#define SCSCR1_CKE0     0x0001

#define SCSSR1_ER	0x0080
#define SCSSR1_TEND	0x0040
#define SCSSR1_TDFE	0x0020
#define SCSSR1_BRK	0x0010
#define SCSSR1_FER	0x0008
#define SCSSR1_PER	0x0004
#define SCSSR1_RDF	0x0002
#define SCSSR1_DR	0x0001


#define SCFCR1_RTRG1    0x0080
#define SCFCR1_RTRG0    0x0040
#define SCFCR1_TTRG1    0x0020
#define SCFCR1_TTRG0    0x0010
#define SCFCR1_MCE      0x0008
#define SCFCR1_TFRST    0x0004
#define SCFCR1_RFRST    0x0002
#define SCFCR1_LOOP     0x0001



/*
 * å쥸
 */
#define	CCR	((LIOREG *)0xffffffec)	


/*
 *  gdb stubˤ
 */

Inline int
stub_putc(int c)
{
  Asm("mov #0x00,r0; mov %0,r4; trapa #0x3f"
               : /* no output */
               : "r"(c)
               : "r0","r4");
  return(c);
}


/*
 *   SH7709AڤSH7709SCIFؤΥݡ󥰤Ǥν
 */

Inline int
scif_putc(int c)
{
    /* Wait TDRD = 1 */
    while((SCIF.SCSSR2 & SCSSR2_TDFE)==0);

    SCIF.SCFTDR2=c;
    SCIF.SCSSR2 = SCIF.SCSSR2 & ~SCSSR2_TDFE;
    return(c);
}



    
/*
 *  SCIˤ
 */

Inline int
sci_putc(int c)
{

    /* Wait TDRD = 1 */
    while((SCI.SCSSR & SCSSR_TDRE)==0);

    SCI.SCTDR=c;
    SCI.SCSSR = SCI.SCSSR & ~SCSSR_TDRE;
    return(c);
}

#endif /* _SH3_H_ */






