/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: jsp_rename.h,v 1.1 2000/11/14 14:44:21 hiro Exp $
 */

/*
 *	ͥ̾Υ͡
 */

#ifndef _JSP_RENAME_H_
#define _JSP_RENAME_H_

/*
 *  cpu_support.S, sys_support.S
 */
#define dispatch		_kernel_dispatch
#define exit_and_dispatch	_kernel_exit_and_dispatch
#define activate_r		_kernel_activate_r
#define ret_int			_kernel_ret_int
#define ret_exc			_kernel_ret_exc

/*
 *  banner.c
 */
#define print_banner		_kernel_print_banner

/*
 *  cpu_config.c, sys_config.c
 */
#define cpu_initialize		_kernel_cpu_initialize
#define cpu_terminate		_kernel_cpu_terminate
#define sys_initialize		_kernel_sys_initialize
#define sys_exit		_kernel_sys_exit
#define sys_putc		_kernel_sys_putc
#define task_intmask		_kernel_task_intmask
#define int_intmask		_kernel_int_intmask
#define board_id		_kernel_board_id
#define board_addr		_kernel_board_addr

/*
 *  task.c
 */
#define task_initialize		_kernel_task_initialize
#define make_runnable		_kernel_make_runnable
#define make_non_runnable	_kernel_make_non_runnable
#define make_dormant		_kernel_make_dormant
#define make_active		_kernel_make_active
#define exit_task		_kernel_exit_task
#define change_priority		_kernel_change_priority
#define rotate_ready_queue	_kernel_rotate_ready_queue
#define calltex			_kernel_calltex
#define runtsk			_kernel_runtsk
#define reqflg			_kernel_reqflg
#define _reqflg			__kernel_reqflg
#define schedtsk		_kernel_schedtsk
#define enadsp			_kernel_enadsp

/*
 *  wait.c
 */
#define wait_complete		_kernel_wait_complete
#define wait_tmout		_kernel_wait_tmout
#define wait_tmout_ok		_kernel_wait_tmout_ok
#define wait_release		_kernel_wait_release
#define wobj_make_wait		_kernel_wobj_make_wait
#define wobj_make_wait_tmout	_kernel_wobj_make_wait_tmout
#define wobj_change_priority	_kernel_wobj_change_priority
#define make_wait_tmout		_kernel_make_wait_tmout
#define wait_cancel		_kernel_wait_cancel

/*
 *  time_event.c
 */
#define tmevt_initialize	_kernel_tmevt_initialize
#define tmevtb_insert		_kernel_tmevtb_insert
#define tmevtb_delete		_kernel_tmevtb_delete
#define current_time		_kernel_current_time
#define next_time		_kernel_next_time

/*
 *  kernel_cfg.c
 */
#define object_initialize	_kernel_object_initialize
#define call_inirtn		_kernel_call_inirtn
#define tmax_tskid		_kernel_tmax_tskid
#define tinib_table		_kernel_tinib_table
#define tcb_table		_kernel_tcb_table
#define tmax_semid		_kernel_tmax_semid
#define seminib_table		_kernel_seminib_table
#define semcb_table		_kernel_semcb_table
#define tmax_flgid		_kernel_tmax_flgid
#define flginib_table		_kernel_flginib_table
#define flgcb_table		_kernel_flgcb_table
#define tmax_dtqid		_kernel_tmax_dtqid
#define dtqcb_table		_kernel_dtqcb_table
#define dtqinib_table		_kernel_dtqinib_table
#define tmax_mbxid		_kernel_tmax_mbxid
#define mbxcb_table		_kernel_mbxcb_table
#define mbxinib_table		_kernel_mbxinib_table
#define tmax_mpfid		_kernel_tmax_mpfid
#define mpfinib_table		_kernel_mpfinib_table
#define mpfcb_table		_kernel_mpfcb_table
#define tmax_cycid		_kernel_tmax_cycid
#define cycinib_table		_kernel_cycinib_table
#define cyccb_table		_kernel_cyccb_table
#define tnum_inhno		_kernel_tnum_inhno
#define inhinib_table		_kernel_inhinib_table
#define tnum_excno		_kernel_tnum_excno
#define excinib_table		_kernel_excinib_table
#define tmevt_heap		_kernel_tmevt_heap

/*
 *  semaphore.c, eventflag.c, dataqueue.c, mailbox.c
 *  mempfix.c, cyclic.c, interrupt.c, exception.c
 */
#define semaphore_initialize	_kernel_semaphore_initialize
#define eventflag_initialize	_kernel_eventflag_initialize
#define dataqueue_initialize	_kernel_dataqueue_initialize
#define mailbox_initialize	_kernel_mailbox_initialize
#define mempfix_initialize	_kernel_mempfix_initialize
#define cyclic_initialize	_kernel_cyclic_initialize
#define interrupt_initialize	_kernel_interrupt_initialize
#define exception_initialize	_kernel_exception_initialize


/*
 *	ͥ̾Υ͡"_" դ륢֥ѡ
 */

/*
 *  cpu_support.S, sys_support.S
 */
#define _dispatch		__kernel_dispatch
#define _exit_and_dispatch	__kernel_exit_and_dispatch
#define _activate_r		__kernel_activate_r
#define _ret_int		__kernel_ret_int
#define _ret_exc		__kernel_ret_exc

/*
 *  banner.c
 */
#define _print_banner		__kernel_print_banner

/*
 *  cpu_config.c, sys_config.c
 */
#define _cpu_initialize		__kernel_cpu_initialize
#define _cpu_terminate		__kernel_cpu_terminate
#define _sys_initialize		__kernel_sys_initialize
#define _sys_exit		__kernel_sys_exit
#define _sys_putc		__kernel_sys_putc
#define _task_intmask		__kernel_task_intmask
#define _int_intmask		__kernel_int_intmask
#define _board_id		__kernel_board_id
#define _board_addr		__kernel_board_addr

/*
 *  task.c
 */
#define _task_initialize	__kernel_task_initialize
#define _make_runnable		__kernel_make_runnable
#define _make_non_runnable	__kernel_make_non_runnable
#define _make_dormant		__kernel_make_dormant
#define _make_active		__kernel_make_active
#define _exit_task		__kernel_exit_task
#define _change_priority	__kernel_change_priority
#define _rotate_ready_queue	__kernel_rotate_ready_queue
#define _calltex		__kernel_calltex
#define _runtsk			__kernel_runtsk
#define _reqflg			__kernel_reqflg
#define __reqflg		___kernel_reqflg
#define _schedtsk		__kernel_schedtsk
#define _enadsp			__kernel_enadsp

/*
 *  wait.c
 */
#define _wait_complete		__kernel_wait_complete
#define _wait_tmout		__kernel_wait_tmout
#define _wait_tmout_ok		__kernel_wait_tmout_ok
#define _wait_release		__kernel_wait_release
#define _wobj_make_wait		__kernel_wobj_make_wait
#define _wobj_make_wait_tmout	__kernel_wobj_make_wait_tmout
#define _wobj_change_priority	__kernel_wobj_change_priority
#define _make_wait_tmout	__kernel_make_wait_tmout
#define _wait_cancel		__kernel_wait_cancel

/*
 *  time_event.c
 */
#define _tmevt_initialize	__kernel_tmevt_initialize
#define _tmevtb_insert		__kernel_tmevtb_insert
#define _tmevtb_delete		__kernel_tmevtb_delete
#define _current_time		__kernel_current_time
#define _next_time		__kernel_next_time

/*
 *  kernel_cfg.c
 */
#define _object_initialize	__kernel_object_initialize
#define _call_inirtn		__kernel_call_inirtn
#define _tmax_tskid		__kernel_tmax_tskid
#define _tinib_table		__kernel_tinib_table
#define _tcb_table		__kernel_tcb_table
#define _tmax_semid		__kernel_tmax_semid
#define _seminib_table		__kernel_seminib_table
#define _semcb_table		__kernel_semcb_table
#define _tmax_flgid		__kernel_tmax_flgid
#define _flginib_table		__kernel_flginib_table
#define _flgcb_table		__kernel_flgcb_table
#define _tmax_dtqid		__kernel_tmax_dtqid
#define _dtqcb_table		__kernel_dtqcb_table
#define _dtqinib_table		__kernel_dtqinib_table
#define _tmax_mbxid		__kernel_tmax_mbxid
#define _mbxcb_table		__kernel_mbxcb_table
#define _mbxinib_table		__kernel_mbxinib_table
#define _tmax_mpfid		__kernel_tmax_mpfid
#define _mpfinib_table		__kernel_mpfinib_table
#define _mpfcb_table		__kernel_mpfcb_table
#define _tmax_cycid		__kernel_tmax_cycid
#define _cycinib_table		__kernel_cycinib_table
#define _cyccb_table		__kernel_cyccb_table
#define _tnum_inhno		__kernel_tnum_inhno
#define _inhinib_table		__kernel_inhinib_table
#define _tnum_excno		__kernel_tnum_excno
#define _excinib_table		__kernel_excinib_table
#define _tmevt_heap		__kernel_tmevt_heap

/*      
 *  semaphore.c, eventflag.c, dataqueue.c, mailbox.c
 *  mempfix.c, cyclic.c, interrupt.c, exception.c
 */
#define _semaphore_initialize	__kernel_semaphore_initialize
#define _eventflag_initialize	__kernel_eventflag_initialize
#define _dataqueue_initialize	__kernel_dataqueue_initialize
#define _mailbox_initialize	__kernel_mailbox_initialize
#define _mempfix_initialize	__kernel_mempfix_initialize
#define _cyclic_initialize	__kernel_cyclic_initialize
#define _interrupt_initialize	__kernel_interrupt_initialize
#define _exception_initialize	__kernel_exception_initialize

#endif /* _JSP_RENAME_H_ */
