/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: time_event.c,v 1.1 2000/11/14 14:44:21 hiro Exp $
 */

/*
 *	।٥ȴ⥸塼
 */

#include "jsp_kernel.h"
#include "check.h"
#include "time_event.h"

/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
SYSTIM	current_time;

/*
 *  ΥƥåΥƥñ: 1ߥá
 */
SYSTIM	next_time;

/*
 *  ƥѻѿñ: 1/TIM_DENOߥá
 */
#if TIC_DENO != 1
UINT	next_subtime;
#endif /* TIC_DENO != 1 */

/*
 *  л֤Υ١ñ: 1ߥá
 */
#if TIC_DENO != 1
EVTTIM	base_time;
#endif /* TIC_DENO != 1 */

/*
 *  ।٥ȥҡפκǽ̤ΰΥǥå
 *
 *  ।٥ȥҡפϿƤ륿।٥Ȥο 1 ä
 *  Τˤʤ롥
 */
static UINT	limit_index;

/*
 *  ।٥ȥҡޥ
 */
#define	PARENT(index)	((index) >> 1)		/* ƥΡɤ */
#define	LCHILD(index)	((index) << 1)		/* λҥΡɤ */
#define	TMEVT_NODE(index)	(tmevt_heap[(index) - 1])

/*
 *  ٥ȯӥޥ
 *
 *  ٥ȯϡcurrent_time ͤӤ롥ʤ
 *  current_time Ǿ͡ʺǤᤤˡcurrent_time - 1 
 *  ʺǤ󤤻ˤȤߤʤӤ롥
 */
#define	EVTTIM_LT(t1, t2) (((t1) - current_time) < ((t2) - current_time))
#define	EVTTIM_LE(t1, t2) (((t1) - current_time) <= ((t2) - current_time))

/*
 *  ޥ⥸塼ν
 */
void
tmevt_initialize()
{
	limit_index = 1;
	current_time = 0;
#if TIC_DENO == 1
	next_time = current_time + TIC_NUME;
#else /* TIC_DENO == 1 */
	next_subtime += TIC_NUME;
	next_time = current_time + next_subtime / TIC_DENO;
	next_subtime %= TIC_DENO;
	base_time = (EVTTIM)(next_time + (next_subtime > 0 ? 1 : 0));
#endif /* TIC_DENO == 1 */
}

/*
 *  ।٥Ȥ֤õ
 *
 *   time ȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפξ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  index ϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
static UINT
tmevt_up(UINT index, EVTTIM time)
{
	UINT	parent;

	while (index > 1) {
		/*
		 *  ƥΡɤΥ٥ȯᤤʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		parent = PARENT(index);
		if (EVTTIM_LE(TMEVT_NODE(parent).time, time)) {
			break;
		}

		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(parent);
		TMEVT_NODE(index).tmevtb->index = index;

		/*
		 *  index ƥΡɤΰ֤˹
		 */
		index = parent;
	}
	return(index);
}

/*
 *  ।٥Ȥ֤򲼸õ
 *
 *   time ȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפβ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  index ϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
static UINT
tmevt_down(UINT index, EVTTIM time)
{
	UINT	child;

	while ((child = LCHILD(index)) < limit_index) {
		/*
		 *  λҥΡɤΥ٥ȯӤᤤ
		 *  ҥΡɤΰ֤ child ꤹ롥ʲλҥΡ
		 *  ϡФ줿λҥΡɤΤȡ
		 */
		if (child + 1 < limit_index
			&& EVTTIM_LT(TMEVT_NODE(child + 1).time,
				  TMEVT_NODE(child).time)) {
			child = child + 1;
		}

		/*
		 *  ҥΡɤΥ٥ȯ٤ʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		if (EVTTIM_LE(time, TMEVT_NODE(child).time)) {
			break;
		}

		/*
		 *  ҥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(child);
		TMEVT_NODE(index).tmevtb->index = index;

		/*
		 *  index ҥΡɤΰ֤˹
		 */
		index = child;
	}
	return(index);
}

/*
 * ।٥ȥҡפؤϿ
 *
 *  ।٥ȥ֥å tmevtb time ǻꤷ֤в˥
 *  ٥Ȥȯ褦ˡ।٥ȥҡפϿ롥
 */
void
tmevtb_insert(TMEVTB *tmevtb, EVTTIM time)
{
	UINT	index;

	/*
	 *  limit_index ֤õ
	 */
	index = tmevt_up(limit_index, time);

	/*
	 *  ।٥Ȥ index ΰ֤롥
	 */ 
	TMEVT_NODE(index).time = time;
	TMEVT_NODE(index).tmevtb = tmevtb;
	tmevtb->index = index;
	limit_index += 1;
}

/*
 *  ।٥ȥҡפκ
 */
void
tmevtb_delete(TMEVTB *tmevtb)
{
	UINT	index = tmevtb->index;
	UINT	parent;
	EVTTIM	event_time = TMEVT_NODE(limit_index - 1).time;

	/*
	 *  Ρɤΰ֤˺ǸΥΡɡlimit_index - 1ΰ
	 *  ΥΡɡˤŬڤʰ֤ذư롥ºݤˤϡ
	 *  ǸΥΡɤºݤΤǤϤʤΡɤΰ
	 *  ֤ΡɤˤʤΤǡǸΥΡɤ٤֤ظ
	 *  ƶΡɤư롥
	 *  ǸΥΡɤΥ٥ȯ郎ΡɤοƥΡ
	 *  Υ٥ȯξˤϡ˸ä֤
	 *  õǤʤˤϡ˸äõ
	 */
	if (index > 1 && EVTTIM_LT(event_time,
				TMEVT_NODE(parent = PARENT(index)).time)) {
		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(parent);
		TMEVT_NODE(index).tmevtb->index = index;

		/*
		 *  ΡɤοƥΡɤ˸ä֤
		 *  õ
		 */
		index = tmevt_up(parent, event_time);
	}
	else {
		/*
		 *  Ρɤ鲼˸ä֤õ
		 */
		index = tmevt_down(index, event_time);
	}

	/*
	 *  ǸΥΡɤ index ΰ֤롥
	 */ 
	TMEVT_NODE(index) = TMEVT_NODE(limit_index - 1);
	TMEVT_NODE(index).tmevtb->index = index;
	limit_index -= 1;
}

/*
 *  ।٥ȥҡפƬΥΡɤκ
 */
Inline void
tmevtb_delete_top()
{
	UINT	index;
	EVTTIM	event_time = TMEVT_NODE(limit_index - 1).time;

	/*
	 *  롼ȥΡɤ˺ǸΥΡɡlimit_index - 1ΰ֤ΥΡɡ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡ
	 *  ɤºݤΤǤϤʤ롼ȥΡɤΡɤˤʤ
	 *  ΤǡǸΥΡɤ٤֤ظƶΡɤư
	 *  롥
	 */
	index = tmevt_down(1, event_time);

	/*
	 *  ǸΥΡɤ index ΰ֤롥
	 */ 
	TMEVT_NODE(index) = TMEVT_NODE(limit_index - 1);
	TMEVT_NODE(index).tmevtb->index = index;
	limit_index -= 1;
}

/*
 *  ƥåζ
 *
 *  TIC_NUME < TIC_DENO λϡȤ鷺˻ιǤ뤬
 *  ɤɤߤ䤹ˤ뤿 #if ¿Ѥ򤱤Ƥ롥
 */
SYSCALL ER
isig_tim()
{
	TMEVTB	*tmevtb;

	CHECK_INTCTX_UNL();
	i_lock_cpu();

	/*
	 *  next_time ꥤ٥ȯᤤʤޤƱ˥।
	 *  ٥Ȥ򡤥।٥ȥҡפХåؿ
	 *  ƤӽФ
	 */
	while (limit_index > 1 && EVTTIM_LE(TMEVT_NODE(1).time, next_time)) {
		tmevtb = TMEVT_NODE(1).tmevtb;
		tmevtb_delete_top();
		(*(tmevtb->callback))(tmevtb->arg);
	}

	/*
	 *  current_time 򹹿롥
	 */
	current_time = next_time;

	/*
	 *  next_timenext_subtimebase_time 򹹿롥
	 */
#if TIC_DENO == 1
	next_time = current_time + TIC_NUME;
#else /* TIC_DENO == 1 */
	next_subtime += TIC_NUME;
	next_time = current_time + next_subtime / TIC_DENO;
	next_subtime %= TIC_DENO;
	base_time = (EVTTIM)(next_time + (next_subtime > 0 ? 1 : 0));
#endif /* TIC_DENO == 1 */

	i_unlock_cpu();
	return(E_OK);
}
